﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TestApp
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.FormBorderStyle = FormBorderStyle.FixedSingle;
            this.AllowTransparency = true;
            TransparencyKey = BackColor;
        }

        private bool Is64Bit
        {
            get { return Marshal.SizeOf(typeof(IntPtr)) == 8; }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (Is64Bit)
            {
                AntiDebugger.Initialize();
                
            }
            else
            {
                AntiDebugger.InitializeSafe();
            }
                button1.Text = "Hide tech. on!";
            button1.Enabled = false;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Resultlabel.Text = (numericUpDown1.Value + numericUpDown2.Value).ToString(); 
        }

    }

    static class AntiDebugger
    {
        [DllImport("ntdll.dll", SetLastError = true, CallingConvention = CallingConvention.StdCall)]
        static extern int NtQueryInformationProcess(IntPtr ProcessHandle, int ProcessInformationClass,
            byte[] ProcessInformation, uint ProcessInformationLength, out int ReturnLength);
        [DllImport("ntdll.dll", SetLastError = true, CallingConvention = CallingConvention.StdCall)]
        static extern uint NtSetInformationProcess(IntPtr ProcessHandle, int ProcessInformationClass,
            byte[] ProcessInformation, uint ProcessInformationLength);
        [DllImport("kernel32.dll")]
        static extern bool CloseHandle(IntPtr hObject);
        [DllImport("kernel32.dll")]
        static extern bool IsDebuggerPresent();
        [DllImport("kernel32.dll")]
        static extern int OutputDebugString(string str);

        public static void Initialize()
        {
            Thread thread = new Thread(AntiDebug);
            thread.IsBackground = true;
            thread.Start(null);
        }
        static void AntiDebug(object thread)
        {
            Thread th = thread as Thread;
            if (th == null)
            {
                th = new Thread(AntiDebug);
                th.IsBackground = true;
                th.Start(Thread.CurrentThread);
                Thread.Sleep(500);
            }
            while (true)
            {
                //Managed
                if (Debugger.IsAttached || Debugger.IsLogging())
                    Environment.FailFast("");

                //IsDebuggerPresent
                if (IsDebuggerPresent())
                    Environment.FailFast("");

                //Open process
                IntPtr ps = Process.GetCurrentProcess().Handle;
                if (ps == IntPtr.Zero)
                    Environment.FailFast("");

                //OutputDebugString
                if (OutputDebugString("") > IntPtr.Size)
                    Environment.FailFast("");

                //Close
                try
                {
                    CloseHandle(IntPtr.Zero);
                }
                catch
                {
                    Environment.FailFast("");
                }

                if (!th.IsAlive)
                    Environment.FailFast("");

                Thread.Sleep(1000);
            }
        }

        public static void InitializeSafe()
        {
            Thread thread = new Thread(AntiDebugSafe);
            thread.IsBackground = true;
            thread.Start(null);
        }
        private static void AntiDebugSafe(object thread)
        {
            Thread th = thread as Thread;
            if (th == null)
            {
                th = new Thread(AntiDebugSafe);
                th.IsBackground = true;
                th.Start(Thread.CurrentThread);
                Thread.Sleep(500);
            }
            while (true)
            {
                if (Debugger.IsAttached || Debugger.IsLogging())
                    Environment.FailFast("");

                if (!th.IsAlive)
                    Environment.FailFast("");

                Thread.Sleep(1000);
            }
        }
    }
}
